Index: doc/Makefile.am
===================================================================
--- doc/Makefile.am	(revision 9e0dd58355074f82df1c04e430a02ace1ad6034a)
+++ doc/Makefile.am	(revision 342e3807d1afbab8032e1d2b74c06f8fec6a92ed)
@@ -1,7 +1,10 @@
-EXTRA_DIST = devel.cfg examples.cfg user.cfg aubio.css \
-	aubionotes.sgml aubioonset.sgml \
-	aubiocut.sgml aubiopitch.sgml aubiotrack.sgml \
-	aubioonset.1 aubionotes.1 \
-	aubiocut.1 aubiopitch.1 aubiotrack.1
+EXTRA_DIST = devel.cfg examples.cfg user.cfg \
+	aubionotes.sgml aubionotes.1 \
+	aubioonset.sgml aubioonset.1 \
+	aubiotrack.sgml aubiotrack.1 \
+	aubiomfcc.sgml  aubiomfcc.1  \
+	aubiopitch.sgml aubiopitch.1 \
+	aubiocut.sgml   aubiocut.1   \
+	aubio.css
 
 man_MANS = aubionotes.1 aubioonset.1 \
Index: doc/aubiomfcc.sgml
===================================================================
--- doc/aubiomfcc.sgml	(revision 342e3807d1afbab8032e1d2b74c06f8fec6a92ed)
+++ doc/aubiomfcc.sgml	(revision 342e3807d1afbab8032e1d2b74c06f8fec6a92ed)
@@ -0,0 +1,166 @@
+<!doctype refentry PUBLIC "-//OASIS//DTD DocBook V4.1//EN" [
+
+<!-- Process this file with docbook-to-man to generate an nroff manual
+     page: `docbook-to-man manpage.sgml > manpage.1'.  You may view
+     the manual page with: `docbook-to-man manpage.sgml | nroff -man |
+     less'.  A typical entry in a Makefile or Makefile.am is:
+
+manpage.1: manpage.sgml
+	docbook-to-man $< > $@
+
+    
+	The docbook-to-man binary is found in the docbook-to-man package.
+	Please remember that if you create the nroff version in one of the
+	debian/rules file targets (such as build), you will need to include
+	docbook-to-man in your Build-Depends control field.
+
+  -->
+
+  <!-- Fill in your name for FIRSTNAME and SURNAME. -->
+  <!ENTITY dhfirstname "<firstname>Paul</firstname>">
+  <!ENTITY dhsurname   "<surname>Brossier</surname>">
+  <!-- Please adjust the date whenever revising the manpage. -->
+  <!ENTITY dhdate      "<date>December 1, 2004</date>">
+  <!-- SECTION should be 1-8, maybe w/ subsection other parameters are
+       allowed: see man(7), man(1). -->
+  <!ENTITY dhsection   "<manvolnum>1</manvolnum>">
+  <!ENTITY dhemail     "<email>piem@altern.org</email>">
+  <!ENTITY dhusername  "Paul Brossier">
+  <!ENTITY dhucpackage "<refentrytitle>AUBIOMFCC</refentrytitle>">
+  <!ENTITY dhpackage   "aubiomfcc">
+
+  <!ENTITY debian      "<productname>Debian</productname>">
+  <!ENTITY gnu         "<acronym>GNU</acronym>">
+  <!ENTITY gpl         "&gnu; <acronym>GPL</acronym>">
+]>
+
+<refentry>
+  <refentryinfo>
+    <address>
+      &dhemail;
+    </address>
+    <author>
+      &dhfirstname;
+      &dhsurname;
+    </author>
+    <copyright>
+      <year>2003</year>
+      <holder>&dhusername;</holder>
+    </copyright>
+    &dhdate;
+  </refentryinfo>
+  <refmeta>
+    &dhucpackage;
+
+    &dhsection;
+  </refmeta>
+  <refnamediv>
+    <refname>&dhpackage;</refname>
+
+    <refpurpose>a command line tool for real time mfcc extraction</refpurpose>
+
+  </refnamediv>
+  <refsynopsisdiv>
+    <cmdsynopsis>
+      <command>&dhpackage; <parameter>[options] [-i soundfile]</parameter></command>
+    </cmdsynopsis>
+  </refsynopsisdiv>
+  <refsect1>
+    <title>DESCRIPTION</title>
+
+    <para><command>&dhpackage;</command> extracts Mel-Frequency Cepstrum
+    Coefficients (MFCC) in audio signals.</para>
+
+    <para>When started without an input file argument
+    (<option>--input</option>), <command>&dhpackage;</command> creates jack
+    input and output ports. When an input file is given, the results are given
+    on the console.</para>
+
+  </refsect1>
+  <refsect1>
+    <title>OPTIONS</title>
+
+    <para>This program follows the usual GNU command line syntax, with long
+    options starting with two dashes (`-').  A summary of options is included
+    below.</para>
+
+<variablelist>
+  <varlistentry>
+  <term><option>-i</option>
+  <option>--input filein</option></term>
+  <listitem>
+
+  <para>Run analysis on this audio file. Most common uncompressed formats are
+  supported.</para>
+
+  </listitem>
+  </varlistentry>
+  <varlistentry>
+  <term><option>-j</option>
+  <option>--jack</option></term>
+  <listitem>
+  <para>Run in jack mode (default when started without input file) and creates a midi output.</para>
+  </listitem>
+  </varlistentry>
+  <varlistentry>
+  <term><option>-v</option>
+  <option>--verbose</option></term>
+  <listitem>
+  <para>Show results on the console (default).</para>
+  </listitem>
+  </varlistentry>
+  <varlistentry>
+  <term><option>-h</option>
+  <option>--help</option></term>
+  <listitem>
+  <para>Show summary of options.</para>
+  </listitem>
+  </varlistentry>
+</variablelist>
+
+  </refsect1>
+  <refsect1>
+    <title>SEE ALSO</title>
+
+    <para>
+    <command>aubiotrack</command>(1)
+    <command>aubionotes</command>(1)
+    <command>aubiocut</command>(1)
+    <command>aubiopitch</command>(1)
+    <command>aubioonset</command>(1)
+    </para>
+
+  </refsect1>
+
+  <refsect1>
+    <title>AUTHOR</title>
+
+    <para>This manual page was written by &dhusername; (&dhemail;). Permission
+    is granted to copy, distribute and/or modify this document under the terms
+    of the &gnu; General Public License, Version 2 any later version published
+    by the Free Software Foundation.</para>
+
+    <para>On Debian systems, the complete text of the GNU General Public
+    License can be found in /usr/share/common-licenses/GPL.</para>
+
+  </refsect1>
+</refentry>
+
+<!-- Keep this comment at the end of the file
+Local variables:
+mode: sgml
+sgml-omittag:t
+sgml-shorttag:t
+sgml-minimize-attributes:nil
+sgml-always-quote-attributes:t
+sgml-indent-step:2
+sgml-indent-data:t
+sgml-parent-document:nil
+sgml-default-dtd-file:nil
+sgml-exposed-tags:nil
+sgml-local-catalogs:nil
+sgml-local-ecat-files:nil
+End:
+-->
+
+